/* priheader.c
   Print Header and Ender

   H.Baba (Rikkyo Univ.)
   May 27, 2003
*/

#define _FILE_OFFSET_BITS 64
#define _LARGEFILE_SOURCE

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>

unsigned char data[0x4000];
int i;

int main(int argc,char *argv[]){
  FILE *fd;
  char *rawdat;
  char runnumber[9],start[19],stop[19],stadate[11],stodate[11],
       header[81],ender[81];
  struct stat fsta;


  if(argc == 1){
    printf("priheader rawdata\n");
    exit(0);
  }

  for(i=1;i<argc;i++){
  memset(runnumber,0,9);
  memset(start,0,19);
  memset(stop,0,19);
  memset(stadate,0,11);
  memset(stodate,0,11);
  memset(header,0,81);
  memset(ender,0,81);


    rawdat = argv[i];
    stat(rawdat,&fsta);
    if((fd = fopen(rawdat,"r")) == NULL){
      perror("Can't open Raw Data.");
      exit(1);
    }
    if(fread(data,1,0x4000,fd) == 0x4000){
      if(data[0] == 1){
	memcpy(runnumber,data+20,8);
	memcpy(start,data+30,18);
	memcpy(stadate,data+86,10);
	memcpy(header,data+100,80);
      }
    }
    fseeko(fd,fsta.st_size-0x4000,SEEK_SET);
    if(fread(data,1,0x4000,fd) == 0x4000){
      if(data[0] == 0xff){
	memcpy(stop,data+48,18);
	memcpy(stodate,data+86,10);
	memcpy(ender,data+100,80);
	if(strcmp(header,ender) == 0){
	  memcpy(ender,data+180,80);
	}
      }
    }

    fclose(fd);
    if(runnumber[0]){
      printf("%s\n",runnumber);
      printf("%s%s\n",start,stadate);
      printf("%s%s\n",stop,stodate);
      printf("Header : %s\n",header);
      printf("Ender  : %s\n",ender);
    }else{
      printf("No Header : %s\n",argv[i]);
    }
    printf("File Size : %0.1fMB\n\n",(double)(fsta.st_size)/1024/1024);
    printf("\n");
  }

  return 0;
}
