/* totalsca.c
   Print Total Scaler Data

   H.Baba (Rikkyo Univ.)
   July 5, 2002
*/

#define _FILE_OFFSET_BITS 64
#define _LARGEFILE_SOURCE

#include <stdio.h>
#include <string.h>
#include <math.h>

char scrname[80][42],tmpname[42],res[256],ans[256],ynn[20];
unsigned long data,scaler[10][80],curscaler[80];
int i,j,mod,scrnum,fnum,findex,k;
int csvmod = 0;

void restoans(int cma){
  int idx,h,d;
  char tmp[256];

  idx = -1;
  memset(ans,0,sizeof(ans));
  memset(tmp,0,sizeof(tmp));
  for(h=0;h<32;h++){
    if(res[h] != '0'){
      idx = h;
      h = 100;
    }
  }
  if(idx == -1){
    strcpy(ans,"0\0");
  }else{
    memcpy(tmp,res+idx,33-idx);
    d = 0;
    for(h=0;h<33-idx;h++){
      ans[d++] = tmp[h];
      if(cma){
	if(((34-idx-h)%3) == 0 && h != 31-idx){
	  ans[d++] = ',';
	}
      }
    }
  }
}

int main(int argc,char *argv[]){
  FILE *fd;
  char rawdat[256],stmp[8];
  unsigned long long int b;

  memset(res,0,sizeof(res));

  if(argc == 1){
    printf("totalsca [-s scalername] rawdata\n");
    printf("totalsca [-csv] rawdata [how many scaler def.=3]\n");
    exit(0);
  }

  scrnum = 0;
  for(i=0;i<80;i++){
    for(j=0;j<10;j++){
      scaler[j][i] = 0;
    }
  }

  if(strcmp("-s",argv[1]) == 0){
    fnum = argc - 3;
    findex = 3;
    if((fd = fopen(argv[2],"r")) == NULL){
      perror("Can't open Scaler Name.");
      exit(1);
    }else{
      while(fgets(tmpname,42,fd) > 0){
	strncpy(scrname[scrnum],tmpname,strlen(tmpname)-1);
	scrnum++;
	if(scrnum >= 80){
	  break;
	}
      }
      fclose(fd);
    }
  }else if(strcmp("-csv",argv[1]) == 0){
    fnum = 1;
    findex = 2;
    csvmod = 1;
    if(argc==4){
      mod = strtol(argv[3],NULL,0);
      if(mod < 1){
	mod = 3;
      }
    }else{
      mod = 3;
    }
    scrnum = mod * 12;
    for(i=0;i<=mod;i++){
      for(j=0;j<12;j++){
	sprintf(scrname[i*12+j],"SCR%d-%d\0",i+1,j+1);
      }
    }
  }else{
    fnum = argc - 1;
    findex = 1;
    printf("How many Scaler Modules? : ");
    scanf("%d",&mod);
    if(mod > 5){
      printf("Too many modules!!\n\a");
      exit(0);
    }
    scrnum = mod * 12;
    for(i=0;i<=mod;i++){
      for(j=0;j<12;j++){
	sprintf(scrname[i*12+j],"SCR%d-%d\0",i+1,j+1);
      }
    }
  }

  /* Print Scaler Name
    for(i=0;i<scrnum;i++){
    printf("%s\n",scrname[i]);
    }
  */

  for(j=findex;j<fnum+findex;j++){
    memset(rawdat,0,sizeof(rawdat));
    strcpy(rawdat,argv[j]);
    if((fd = fopen(rawdat,"r")) == NULL){
      printf("Can't open %s\n",rawdat);
      printf("Continue? [y/n] : ");
      scanf("%s",ynn);
      if(ynn[0] != 'y'){
	exit(0);
      }
    }else{
      printf("Now reading %s ... \n",rawdat);
      while(fread(&data,4,1,fd) == 1){
	if(data == 0x00000000){
	  fseek(fd,0x4000-4-scrnum*4,SEEK_CUR);
	  fread(curscaler,4,scrnum,fd);
	  for(i=0;i<scrnum;i++){
	    scaler[0][i] += curscaler[i];
	    for(k=0;k<3;k++){
	      if(scaler[k][i] >= 100000000){
		scaler[k+1][i] += 1;
		scaler[k][i] -= 100000000;
	      }
	    }
	  }
	}else{
	  fseek(fd,0x4000-4,SEEK_CUR);
	}
      }
      fclose(fd);
    }
  }
  /* Print Scaler Data */
  /* printf("%s\n\n",rawdat); */
  if(!csvmod){
    for(i=0;i<scrnum;i++){
      memset(res,0,sizeof(res));
      for(j=0;j<4;j++){
	memset(stmp,0,sizeof(stmp));
	sprintf(stmp,"%08u",scaler[j][i]);
	memcpy(res+24-(8*j),stmp,8);
      }
      restoans(1);
      printf("%24s : %20s\n",scrname[i],ans);
    }
  }else{
    for(i=0;i<scrnum;i++){
      memset(res,0,sizeof(res));
      for(j=0;j<4;j++){
	memset(stmp,0,sizeof(stmp));
	sprintf(stmp,"%08u",scaler[j][i]);
	memcpy(res+24-(8*j),stmp,8);
      }
      restoans(0);
      printf("%s",ans);
      if(i<scrnum-1){
	printf(",");
      }
    }
    printf("\n");
  }
  return 0;
}

